{$R-,S-}
Unit DosEnv1;

INTERFACE

{
FUNCTION ModifyEnv(EnvSeg, EnvSize : WORD;
		     VAR pattern : STRING): BOOLEAN;
}

FUNCTION ModifyDosEnv(pattern : STRING): BOOLEAN;

FUNCTION ModifyMasterEnv(pattern : STRING): BOOLEAN;

VAR
  Command_env, Max_Env_Size : WORD;

IMPLEMENTATION

FUNCTION ModifyEnv(EnvSeg, EnvSize : WORD; VAR pattern : STRING): BOOLEAN;
TYPE
  ByteArr = ARRAY [0..MaxInt] OF BYTE;
  pByteArr = ^ByteArr;
LABEL
  Found;
VAR
  EnvLen,
  equal, room, start, lengde : WORD;
  i, p : WORD;
  pt : pByteArr;
BEGIN
  ModifyEnv := FALSE;
  EnvLen := $FFFF;
  REPEAT
    Inc(EnvLen);
  UNTIL MemW[EnvSeg:EnvLen] = 0;          { Including BOTH zero'es! }
  Inc(EnvLen,2);

  equal := 0;
  REPEAT
    Inc(equal);
    IF equal > Length(pattern) THEN Exit;
  UNTIL pattern[equal] = '=';

  FOR room := 1 TO equal-1 DO
    pattern[room] := UpCase(pattern[room]);

  pt := Ptr(EnvSeg,0);
  REPEAT
    p := 0;
    WHILE pt^[p] <> 0 DO Inc(p);
    IF (p = 0) OR (p >= MaxInt) THEN BEGIN
      lengde := 0;
      GOTO Found;
    END;
    Inc(p);

    i := 0;
    WHILE (i < equal) AND (pt^[i] = BYTE(pattern[i+1])) DO Inc(i);
    IF i = equal THEN BEGIN
      start := Word(pt);
      lengde := p;
      Goto Found;
    END;
    Inc(Word(pt),p);
  UNTIL Word(pt) > EnvLen;
  lengde := 0;

Found:

  room := EnvSize - EnvLen + lengde;
  IF room <= Length(pattern) THEN Exit;
  IF lengde > 0 THEN BEGIN	{ Remove current string }
    Move(Mem[EnvSeg:start+lengde],Mem[EnvSeg:start],
         EnvSize - (start + lengde));
    Dec(EnvLen,lengde);
  END;
  IF Length(pattern) > equal THEN BEGIN
    Move(pattern[1],Mem[EnvSeg:EnvLen-1],Length(pattern));
    Inc(EnvLen,Length(pattern)+1);
    MemW[EnvSeg:EnvLen-2] := 0;
  END;
  ModifyEnv := TRUE;
END;

FUNCTION ModifyDosEnv(pattern : STRING): BOOLEAN;
VAR
  EnvLen,
  Command_Seg,
  Command_Env : WORD;
BEGIN
  Command_Seg := MemW[PrefixSeg:$10];
  Command_Env := MemW[Command_Seg:$2C];
  IF Command_Env = 0 THEN
    Command_Env := Command_Seg + MemW[Command_Seg-1:3] + 1;
(*
  command_env := $0F4D;                        {Hard-coded for debug}
*)
  ModifyDosEnv := ModifyEnv(Command_Env, MemW[Command_Env-1:3]*16, pattern);
END;

Function FirstMCB : Word;
Assembler;
ASM
  mov ah,$52
  int $21
  mov ax,[es:bx-2]
END;

FUNCTION ModifyMasterEnv(pattern : STRING): BOOLEAN;
VAR
  mcb,
  Command_Seg,
  Command_Env : WORD;
BEGIN
  mcb := FirstMCB;
  WHILE MemW[mcb:1] <> mcb+1 DO
    Inc(mcb,MemW[mcb:3]+1);

  Command_Seg := mcb+1;

  Command_Env := MemW[Command_Seg:$2C];
  IF Command_Env = 0 THEN
    Command_Env := Command_Seg + MemW[mcb:3] + 1;

  ModifyMasterEnv := ModifyEnv(Command_Env, MemW[Command_Env-1:3]*16, pattern);
END;


END.
